<?php
/*
CMSimple kissgallery plugin version 0.1
History:
- 0.4 Just some clean up
- 0.3 Fixed:
		* Thumbnail function is rewritten
		* Delete last image fixed
      New:
	  	* Options/Config thumb_fixed_size: false/true - when is true the thumbnail will be trimed and resized
		* Rebuild all thumbnails
- 0.2 First public release
		* Code cleanup
		* Error checking
- 0.1 First internal release
*/
if (!defined('KISSLIBV')) require dirname(__FILE__)."/kiss.php";

function saveThumb($arr_img, $thumbnail, $dst_width, $dst_height, $quality) {
	$src_width = $arr_img["w"];
	$src_height = $arr_img["h"];
	$srcImage=$arr_img["img"];
	$src_ratio=$src_height/$src_width;
	$dst_ratio=$dst_height/$dst_width;

	@$dstImage = imagecreatetruecolor($dst_width, $dst_height);
	@imageantialias($dstImage);
	$white = imagecolorallocate($dstImage, 255, 255, 255);
	imagefill($dstImage, 0, 0, $white);

	$dst_x=0;
	$dst_y=0;
	$src_x=0;
	$src_y=0;
	$dst_w=$dst_width;
	$dst_h=$dst_height;
	$src_w=$src_width;
	$src_h=$src_height;
	
	if (($src_width<$dst_width) || ($src_height<$dst_height)) {
		if ($src_width<$dst_width) {
			$dst_x=($dst_width-$src_width)/2; 
			$dst_w=$src_width;
			if ($src_height>$dst_height) {
				$src_y=($src_height-$dst_height)/2;
				$src_h=$dst_height;
			}
		}
		if ($src_height<$dst_height) {
			$dst_y=($dst_height-$src_height)/2; 
			$dst_h=$src_height;
			if ($src_width>$dst_width) {
				$src_x=($src_width-$dst_width)/2;
				$src_w=$dst_width;
			}
		}
	} else {
		$rh=$src_height/$dst_height;
		$rw=$src_width/$dst_width;
		if ($rh>$rw) {
			$src_h=$src_width*$dst_ratio;
			$src_y=($src_height-$src_h)/2;
		} else {
			$src_w=$src_height/$dst_ratio;
			$src_x=($src_width-$src_w)/2;
		}
	} 
	@imagecopyresampled($dstImage, $srcImage, $dst_x, $dst_y , $src_x, $src_y, $dst_w, $dst_h, $src_w, $src_h);
	@imagejpeg($dstImage, $thumbnail, $quality);
}

function getSizes($src_w, $src_h, $dst_w, $dst_h ) {
   $mlt_w = $dst_w / $src_w;
   $mlt_h = $dst_h / $src_h;
   $mlt = $mlt_w < $mlt_h ? $mlt_w:$mlt_h;
   if ($dst_w == "*") $mlt = $mlt_h;
   if ($dst_h == "*") $mlt = $mlt_w;
   if ($dst_w == "*" && $dst_h == "*") $mlt=1;
   #### Calculate new dimensions
   $img_new_w =  round($src_w * $mlt);
   $img_new_h =  round($src_h * $mlt);
   return array("w" => $img_new_w, "h" => $img_new_h, "mlt_w"=>$mlt_w, "mlt_h"=>$mlt_h,  "mlt"=>$mlt);
}  

function imgGetResized($img_original,$img_w,$img_h,$img_new_w,$img_new_h) {
   $img_resized = imagecreatetruecolor($img_new_w,$img_new_h);
   imagecopyresampled($img_resized, $img_original, 0, 0, 0, 0,$img_new_w, $img_new_h, $img_w, $img_h);
   return $img_resized;
} 

function saveImage($arr_img,$filename,$w,$h,$qty) {
  if ($arr_img["w"] > $w || $arr_img["h"] > $h) {
    $wh = getSizes($arr_img["w"], $arr_img["h"], $w, $h);
    $img_res = imgGetResized($arr_img["img"],$arr_img["w"],$arr_img["h"],$wh["w"],$wh["h"]);
    ImageJPEG($img_res,$filename,$qty);
  } else {
    ImageJPEG($arr_img["img"],$filename,$qty);
  }
}

function imageFromUpload($uploaded_file){
   $img_sz =  getimagesize($uploaded_file );     
   switch($img_sz[2] ){
       case 1:
           $img_type = "GIF";
           $img = ImageCreateFromGif($uploaded_file);
       break;
       case 2:
           $img = ImageCreateFromJpeg($uploaded_file);
           $img_type = "JPG";
       break;
       case 3:
           $img = ImageCreateFromPng($uploaded_file);
           $img_type = "PNG";
       break;
       case 4:
           $img = ImageCreateFromSwf($uploaded_file);
           $img_type = "SWF";
       break;
       default: return array(false);
   }
   return array("img"=>$img, "w"=>$img_sz[0], "h"=>$img_sz[1], "type"=>$img_sz[2], "html"=>$img_sz[3]);
} 

function getImage($img,$id,$filepath) {
	global $plugin_cf;
    $arr_img = imageFromUpload($img);
	if ($arr_img['img']) {
		saveImage($arr_img,$filepath.'/'.$id.'.jpg',$plugin_cf['kissgallery']['max_size_photo'],$plugin_cf['kissgallery']['max_size_photo'],$plugin_cf['kissgallery']['jpeg_quality']);
		saveImage($arr_img,$filepath.'/'.$id.'s.jpg',$plugin_cf['kissgallery']['max_size_small'],$plugin_cf['kissgallery']['max_size_small'],$plugin_cf['kissgallery']['jpeg_quality']);
		if (kissIsTrue($plugin_cf['kissgallery']['thumb_fixed_size']))
			saveThumb($arr_img,$filepath.'/'.$id.'t.jpg',$plugin_cf['kissgallery']['thumb_width'],$plugin_cf['kissgallery']['thumb_height'],$plugin_cf['kissgallery']['jpeg_quality']);
		else
			saveImage($arr_img,$filepath.'/'.$id.'t.jpg',$plugin_cf['kissgallery']['thumb_width'],$plugin_cf['kissgallery']['thumb_height'],$plugin_cf['kissgallery']['jpeg_quality']);
		imagedestroy($arr_img["img"]);
		return true;
	} else {
		return false;
	}
} 

function rebuild_thumbs($files) {
	global $plugin_cf, $filepath;
	foreach ($files as $num => $rec) {
		$id=$rec[0];
	    $arr_img = imageFromUpload($filepath.'/'.$id.'.jpg');
		$rc=unlink($filepath.'/'.$id.'t.jpg');
		if (kissIsTrue($plugin_cf['kissgallery']['thumb_fixed_size']))
			saveThumb($arr_img,$filepath.'/'.$id.'t.jpg',$plugin_cf['kissgallery']['thumb_width'],$plugin_cf['kissgallery']['thumb_height'],$plugin_cf['kissgallery']['jpeg_quality']);
		else
			saveImage($arr_img,$filepath.'/'.$id.'t.jpg',$plugin_cf['kissgallery']['thumb_width'],$plugin_cf['kissgallery']['thumb_height'],$plugin_cf['kissgallery']['jpeg_quality']);
	}
}

if(isset($kissgallery)) {
	$admin=kissGetVar('admin');
	$action=kissGetVar('action');
	$plugin=basename(dirname(__FILE__),"/");
	$fngroup=dirname(__FILE__).'/data/album.txt';
	$fnfile=dirname(__FILE__).'/data/photo.txt';
    $imgpath=$pth['folder']['plugins'].$plugin."/images";
    $filepath=$pth['folder']['plugins'].$plugin."/photos";
		
	kissWriteAccess($fngroup);
	kissWriteAccess($fnfile);
	kissWriteAccess($pth['folder']['plugins']."$plugin/config/config.php");
	kissWriteAccess($pth['folder']['plugins']."$plugin/css/stylesheet.css");
	kissWriteAccess($pth['folder']['plugins']."$plugin/languages/$sl.php");
	kissWriteAccess($filepath);
		
	$o.=print_plugin_admin('on');
	if($admin<>'plugin_main'){$o.=plugin_admin_common($action,$admin,$plugin);}
	if($admin=='')$o.='<br /><hr size="1" />
					<font size = 3><strong>kissGallery - Plugin</strong></font>
					<hr size="1" />
					Version: v0.4 - Beta<br />
					Library: v'.KISSLIBV.'<br />
					Released: 12.02.2008<br />
					Developed by: Claus H&oslash;jberg (alias Softly)<br />
					Email:<a href="mailto:cmsimple@softly.dk">&nbsp;cmsimple@softly.dk</a><br />
					Website:<a target="_blank" href="http://softly.dk/?CMSimple">&nbsp;softly.dk?CMSimple</a><br />
					<br />kissGallery is powered by <a target="_blank" href="http://mootools.net/">MooTools</a> and <a target="_blank" href="http://www.digitalia.be/software/slimbox">SlimBox</a><br />
					<br />Support for external image browser in <a target="_blank" href="http://tinymce.moxiecode.com/">TinyMce</a>  <br />
					<br />New in this release:
					<br />&nbsp;&nbsp;- Code clean up
					<br />&nbsp;&nbsp;- Some more documentation
					
					<hr size="1" />';
	if ($admin == 'plugin_main') {
		$id=kissGetVar('id');
		$gid=kissGetVar('gid');
		$groups=kissRFile($fngroup);
		if ($action=='save_group') {
			$order=kissGetNumber(kissGetVar('order'));
			$name=strtr(kissGetVar('name'),"#","_");
			$desc=strtr(kissGetVar('desc'),"#","_");
			if ($gid==0) {
				$gid=kissNextID($groups);
				$groups[]=array($gid,$order,$name,$desc);
			} else {
				foreach ($groups as $num => $rec) {
					if ($rec[0]==$gid) {
						$groups[$num][1]=$order;
						$groups[$num][2]=$name;
						$groups[$num][3]=$desc;
					}
				}
			}
			kissWFile($fngroup,$groups);
			$groups=kissRFile($fngroup);
		}
		if ($action=='edit_group') {
			foreach ($groups as $num => $rec) {
				if ($rec[0]==$gid) {
					$order=$rec[1];
					$name=$rec[2];
					$desc=$rec[3];
				}
			}
			$o .='<form method="post" action="'.$sn.'?'.amp().$plugin.'">';
			$o .="<fieldset><legend>".$plugin_tx['kissgallery']['edit_record']."</legend>";
			$o .="<table>";
			$o .="<tr><td><label>".$plugin_tx['kissgallery']['group_id']."</label></td><td>$gid</td></tr>";
			$o .="<tr><td><label>".$plugin_tx['kissgallery']['order_id']."</label></td><td><input type='text' class='text' size='64' value=\"$order\" name='order' width='64'></td></tr>";
			$o .="<tr><td><label>".$plugin_tx['kissgallery']['group']."</label></td><td><input type='text' class='text' size='64' value=\"$name\" name='name' width='64'></td></tr>";
			$o .="<tr><td><label>".$plugin_tx['kissgallery']['description']."</label></td><td><input type='text' class='text' size='64' value=\"$desc\" name='desc' width='64'></td></tr>";
			$o .="<tr><td><input type='submit' value=".ucfirst(strtolower($tx['action']['save']))." name='save' id='save'></td><td></td></tr>";
			$o .="</table>";
			$o .="</fieldset>";
			$o .="<input type='hidden' value='$admin' name='admin'>";
			$o .="<input type='hidden' value='save_group' name='action'>";
			$o .="<input type='hidden' value=\"$gid\" name='gid'>";
			$o .="</form>";
		}

		$files=kissRFile($fnfile);
		if ($action=='save_file') {
			$order=kissGetNumber(kissGetVar('order'));
			$file_name=kissGetVar('file_name');
			$desc=strtr(kissGetVar('desc'),"#","_");
			if ($id==0) {
				$file_name = strtolower($GLOBALS['HTTP_POST_FILES']['file_name']['name']);
				if ($desc=='') $desc=$file_name;
				if ($order=='') $order=time();
				$file_size = $GLOBALS['HTTP_POST_FILES']['file_name']['size'];
				$file_tmp = $GLOBALS['HTTP_POST_FILES']['file_name']['tmp_name'];
				$file_type = $GLOBALS['HTTP_POST_FILES']['file_name']['type'];
				$ext='/\\'.str_replace(',','|\\',$plugin_cf['kissgallery']['file_extension']).'/i';
				if (!(preg_match($ext, $file_name))) $e.='<li>'.$tx['error']['wrongext'].' '.$file_name.'</li>';
				if ($file_size > $plugin_cf['kissgallery']['max_filesize']) $e .= '<li>'.$file_name.' '.$tx['error']['tolarge'].' '.$plugin_cf['kissgallery']['max_filesize'].' '.$tx['files']['bytes'].'</li>';
				if (!$e) {
					$id=kissNextID($files);
					if (getImage($file_tmp,$id,$filepath)) {
						$o .= '<p>'.ucfirst($tx['filetype']['file']).' '.$file_name.' '.$tx['result']['uploaded'].'</p>';
						$file_datetime=time();
						$files[]=array($id,$order,$gid,$file_name,$file_datetime,$file_type,$desc);
					}
					else e('cntsave', 'file', $file_name);
				}
			} else {
				foreach ($files as $num => $rec) {
					if ($rec[0]==$id) {
						$files[$num][1]=$order;
						$files[$num][2]=$gid;
						$files[$num][6]=$desc;
					}
				}
			}
			kissWFile($fnfile,$files);
  			$files=kissRFile($fnfile);
		}
		if ($action=='delete_file') {
			$tarr=array();
			foreach ($files as $num => $rec) {
				if ($rec[0]==$id) {
					$rrr=unlink("$filepath/$id.jpg");
					$rrr=unlink("$filepath/$id"."s.jpg");
					$rrr=unlink("$filepath/$id"."t.jpg");
				} else {
					$tarr[]=$rec;
				}
			}
			kissWFile($fnfile,$tarr);
  			$files=kissRFile($fnfile);
		}
		if ($action=='edit_file' || kissGetVar('more')) {
			if (kissGetVar('more')) $id=0;
			$order='';
			$file_name='';
			$file_datetime=0;
			$desc='';
			foreach ($files as $num => $rec) {
				if ($rec[0]==$id) {
					$order=$rec[1];
					$gid=$rec[2];
					$file_name=$rec[3];
					$file_datetime=date($plugin_cf['kissgallery']['datetime_format'],$rec[4]);
					$desc=$rec[6];
				}
			}
			$o .='<form method="post" action="'.$sn.'?'.amp().$plugin.'" enctype="multipart/form-data">';
			$o .="<fieldset><legend>".$plugin_tx['kissgallery']['edit_record']."</legend>";
			$o .="<table>";
			if (!$id==0) $o .="<tr><td><label></label></td><td><img src=\"$filepath/$id"."t.jpg\" style=\"border: 1px dotted black;\"></td></tr>";
			$o .="<tr><td><label>".$plugin_tx['kissgallery']['file_id']."</label></td><td>$id</td></tr>";
			$o .="<tr><td><label>".$plugin_tx['kissgallery']['file_name']."</label></td><td>";
			if ($id==0) $o .="<input type='file' class='text' size='40' value=\" \" name='file_name' width='64'></td></tr>";
			else $o .="$file_name</td></tr>";
			if ($id>0) $o .="<tr><td><label>".$plugin_tx['kissgallery']['file_datetime']."</label></td><td>$file_datetime</td></tr>";
			$o .="<tr><td><label>".$plugin_tx['kissgallery']['order_id']."</label></td><td><input type='text' class='text' size='64' value=\"$order\" name='order' width='64'></td></tr>";
			$o .="<tr><td><label>".$plugin_tx['kissgallery']['description']."</label></td><td><input type='text' class='text' size='64' value=\"$desc\" name='desc' width='64'></td></tr>";
			$o .="<tr><td><label>".$plugin_tx['kissgallery']['group_id']."</label></td><td><select name='gid'>";
			foreach ($groups as $num => $rec) {
				$o .="<option value=\"$rec[0]\"";
				if ($rec[0]==$gid) {
					$o .=' SELECTED';
				}
				$o .= ">$rec[2]</option>";
			}
			$o .="</select></td></tr>";
			if ($id==0)	$o .="<tr><td></td><td><input type='checkbox' class='text' name='more' checked>&nbsp;".$plugin_tx['kissgallery']['more_uploads']."</td></tr>";
			$o .="<tr><td><input type='submit' value=".ucfirst(strtolower($tx['action']['save']))." name='save' id='save'></td><td></td></tr>";
			$o .="</table>";
			$o .="</fieldset>";
			$o .="<input type='hidden' value='$admin' name='admin'>";
			$o .="<input type='hidden' value='save_file' name='action'>";
			$o .="<input type='hidden' value=\"$id\" name='id'>";
			$o .="</form>";
		}
		if ($action=='rebuild_thumbs') rebuild_thumbs($files);
		if ($action!='edit_file' && $action!='edit_group' && !kissGetVar('more')) {
			$o.='<br><table class="edit" width="100%" cellpadding="1" cellspacing="0" border="1">';
			$o.="<tr><td colspan=\"4\"><form>".$plugin_tx['kissgallery']['group'].": <select name=\"gid\" onchange=\"location.href=this.options[this.selectedIndex].value\">";
			if ($gid=='') $gid=$groups[0][0];
			foreach ($groups as $num => $rec) {
				$o .="<option value=\"$sn?&$plugin&admin=$admin&action=list_files&gid=$rec[0]\"".(($rec[0] == $gid)?' selected="selected"':'').">$rec[2] [id:$rec[0]]</option>";
			}
			$o.="</select>";
			if (sizeof($groups)>0) $o.="&nbsp;&nbsp;<a href=\"".$sn.'?'.amp().$plugin."&admin=$admin&action=edit_group&gid=$gid\"><img align=\"absbottom\" src=\"$imgpath/edit.gif\"></a>";
			$o.="&nbsp;&nbsp;<a href=\"".$sn.'?'.amp().$plugin."&admin=$admin&action=edit_group&gid=0\"><img align=\"absbottom\" src=\"$imgpath/add.gif\"></a>";
			$o.="&nbsp;&nbsp;|&nbsp;&nbsp;<a href=\"".$sn.'?'.amp().$plugin."&admin=$admin&action=rebuild_thumbs\">".$plugin_tx['kissgallery']['rebuild_thumbnails']."</a>&nbsp;&nbsp;|";
			$o.="</form></td></tr>";
			if (sizeof($groups)>0) {
				$o.='<tr><td  width="45px">'."<a href=\"".$sn.'?'.amp().$plugin."&admin=$admin&action=edit_file&id=0&gid=$gid\"><img src=\"$imgpath/add.gif\"></a>".'</td><td width="10%">'.$plugin_tx['kissgallery']['file_id'].'</td><td>'.$plugin_tx['kissgallery']['name'].'</td><td>'.$plugin_tx['kissgallery']['description'].'</td></tr>';
				foreach ($files as $num => $rec) {
					if ($gid==$rec[2]) {
						$o.='<tr><td>'."<a href=\"".$sn.'?'.amp().$plugin."&admin=$admin&action=edit_file&id=$rec[0]\"><img src=\"$imgpath/edit.gif\"></a>"
       			            ."&nbsp;&nbsp;<a href=\"".$sn.'?'.amp().$plugin."&admin=$admin&action=delete_file&id=$rec[0]&gid=$gid\"><img src=\"$imgpath/delete.gif\"></a>".'</td>'					
						    .'<td align="right">'.$rec[0].'</td><td>'.$rec[3].'</td><td>'.$rec[6].'</td></tr>';
					}
				}
			}
			$o.='</table>';
		}
	}
}
?>